﻿Imports System.Diagnostics

Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Text = AppTitleAndVersion()
        '
        SetDefaultValues()
        '
        FileName = "LogFile.csv"
        Load_INI()
        InitFileName()
        '
        LoadSlotNames()
        SetSlotParams()
        '
        txt_SlotDisplay1.Focus()
        '
        SetRunButtonDefaultText()
        If CHK_Run.Checked Then StartRun()
        '
        Timer1.Interval = 50
        Timer1.Start()
        '
        EventsAreEnabled = True
        '
        Me.Refresh()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        StopRun()
        Save_INI()
    End Sub

    ' ==============================================================================================================
    '  RUN and STOP
    ' ==============================================================================================================
    Private Sub CHK_Run_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CHK_Run.CheckedChanged
        If Not EventsAreEnabled Then Return
        If CHK_Run.Checked Then
            StartRun()
        Else
            StopRun()
        End If
    End Sub

    Private Sub InitFileName()
        FileName = TXT_LogFileName.Text
        FileName = ".\LOGS\" + FileName
    End Sub

    Private Sub StartRun()
        SetRunButtonDefaultText()
        TXT_LogFileName.Enabled = False
        TXT_CommandsSlot.Enabled = False
        TXT_Interval.Enabled = False
        CHK_BackupLogFiles.Enabled = False
        CHK_AddHeadingText.Enabled = False
        CHK_DateAndTime.Enabled = False
        CHK_JulianDate.Enabled = False
        Panel1.Enabled = False
        If CHK_BackupLogFiles.Checked And IO.File.Exists(FileName) Then
            BackupLogFile()
        End If
        InitLogFile()
        SetFastTimer_Interval()
        FastTimer_Start()
    End Sub

    Private Sub StopRun()
        FastTimer_Stop()
        If CHK_BackupLogFiles.Checked And IO.File.Exists(FileName) Then
            BackupLogFile()
        End If
        TXT_LogFileName.Enabled = True
        TXT_CommandsSlot.Enabled = True
        TXT_Interval.Enabled = True
        CHK_BackupLogFiles.Enabled = True
        CHK_AddHeadingText.Enabled = True
        CHK_DateAndTime.Enabled = True
        CHK_JulianDate.Enabled = True
        Panel1.Enabled = True
        SetRunButtonDefaultText()
    End Sub

    Friend Sub SetRunButtonDefaultText()
        CHK_Run.Text = "R U N"
    End Sub

    Private Sub InitLogFile()
        Dim s As String = ""
        If CHK_AddHeadingText.Checked Then
            ' ----------------------------------------------------- If the "_Heading_Text_.txt" file exists then add HEADING TEXT
            Dim f As String
            f = Application.StartupPath + "\LOGS\_Heading_Text_.txt"
            If IO.File.Exists(f) Then
                s = IO.File.ReadAllText(f)
                If s <> "" Then s += vbCrLf
            End If
            ' ----------------------------------------------------- Add Date and Time
            If AddDateAndTime Then
                s += "Date Time and Millisecs" + FieldSeparator
            End If
            ' ----------------------------------------------------- Add OA date or Julian date
            If AddJulianDate Then
                's += "OADate          " + FieldSeparator
                s += "JulianDate      " + FieldSeparator
            End If
            ' ----------------------------------------------------- Add SlotName fields
            For i As Int32 = 0 To Slot.Length - 1
                If SensorType(i) <> "Unused" AndAlso SlotName(i) IsNot Nothing Then
                    s += SlotName(i).PadRight(10) + FieldSeparator
                End If
            Next
            ' ----------------------------------------------------- Remove the last separator
            If s <> "" Then s = Strings.Left(s, s.Length - 1)
        End If
        ' --------------------------------------------------------- Add separator
        s += vbCrLf + StrDup(80, "-") + "START"
        ' --------------------------------------------------------- Init LogFile name
        If TXT_LogFileName.Text = "" Then
            TXT_LogFileName.Text = "LogFile.csv"
            InitFileName()
        End If
        ' --------------------------------------------------------- Init LogFile eventually with the first line
        IO.Directory.CreateDirectory(IO.Path.GetDirectoryName(FileName))
        Dim file As System.IO.StreamWriter
        file = My.Computer.FileSystem.OpenTextFileWriter(FileName, _
                                                         False, _
                                                         New System.Text.ASCIIEncoding())
        file.WriteLine(s)
        file.Close()
        ' --------------------------------------------------------- Set the Creation-Time
        IO.File.SetCreationTime(FileName, Now)
    End Sub

    Private Sub SetFastTimer_Interval()
        Dim n As Int32 = CInt(Val(TXT_Interval.Text) * 1000)
        If n <= 0 Then n = 1
        FastTimerMillisec = n
    End Sub

    Private Sub SetDefaultValues()
        cmb_Type1.SelectedIndex = 0
        cmb_Type2.SelectedIndex = 0
        cmb_Type3.SelectedIndex = 0
        cmb_Type4.SelectedIndex = 0
        cmb_Type5.SelectedIndex = 0
        cmb_Type6.SelectedIndex = 0
        cmb_Type7.SelectedIndex = 0
        cmb_Type8.SelectedIndex = 0
        cmb_Type9.SelectedIndex = 0
        cmb_Type10.SelectedIndex = 0
        cmb_Type11.SelectedIndex = 0
        cmb_Type12.SelectedIndex = 0
        '
        txt_NumSlot1.NumericValueInteger = 101
        txt_NumSlot2.NumericValueInteger = 102
        txt_NumSlot3.NumericValueInteger = 103
        txt_NumSlot4.NumericValueInteger = 104
        txt_NumSlot5.NumericValueInteger = 105
        txt_NumSlot6.NumericValueInteger = 106
        txt_NumSlot7.NumericValueInteger = 107
        txt_NumSlot8.NumericValueInteger = 108
        txt_NumSlot9.NumericValueInteger = 109
        txt_NumSlot10.NumericValueInteger = 110
        txt_NumSlot11.NumericValueInteger = 111
        txt_NumSlot12.NumericValueInteger = 112
    End Sub


    ' ==============================================================================================================
    '  UPPER BAR CONTROLS
    ' ==============================================================================================================
    Private Sub BTN_OpenFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BTN_OpenFile.Click
        On Error Resume Next
        Process.Start(FileName)
    End Sub
    Private Sub BTN_OpenFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BTN_OpenFolder.Click
        IO.Directory.CreateDirectory(IO.Path.GetDirectoryName(FileName))
        Process.Start(IO.Path.GetDirectoryName(FileName))
    End Sub
    Private Sub BTN_EditHeadingText_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BTN_EditHeadingText.Click
        Dim f As String = Application.StartupPath + "\LOGS\_Heading_Text_.txt"
        If Not IO.File.Exists(f) Then
            Dim str As String = ""
            str += "=================================================================" + vbCrLf
            str += "HEADING TEXT EXAMPLE" + vbCrLf
            str += "-----------------------------------------------------------------" + vbCrLf
            str += "IF YOU WRITE SOMETHING IN THIS FILE" + vbCrLf
            str += "THEN IT WILL APPEAR IN THE HEADING OF EACH FILE" + vbCrLf
            str += "================================================================="
            IO.File.WriteAllText(f, Str, System.Text.Encoding.UTF8)
        End If
        Process.Start(f)
    End Sub

    Private Sub TXT_LogFileName_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TXT_LogFileName.TextChanged
        If Not EventsAreEnabled Then Return
        InitFileName()
        Save_INI()
    End Sub
    Private Sub CHK_BackupLogFiles_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CHK_BackupLogFiles.CheckedChanged
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub
    Private Sub CHK_AddFirstLine_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CHK_AddHeadingText.CheckedChanged
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub
    Private Sub CHK_DateAndTime_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CHK_DateAndTime.CheckedChanged
        AddDateAndTime = CHK_DateAndTime.Checked
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub
    Private Sub CHK_JulianDate_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CHK_JulianDate.CheckedChanged
        AddJulianDate = CHK_JulianDate.Checked
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub
    Private Sub TXT_CommandsSlot_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TXT_CommandsSlot.TextChanged
        CommandsSlot = TXT_CommandsSlot.NumericValueInteger
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub
    Private Sub TXT_Interval_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TXT_Interval.TextChanged
        SetFastTimer_Interval()
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub

    ' ==============================================================================================================
    '  CHANNEL CONTROLS
    ' ==============================================================================================================
    Private Sub txt_NumSlot1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_NumSlot1.TextChanged
        Slot(0) = CInt(Val(txt_NumSlot1.Text))
        If Not EventsAreEnabled Then Return
        SetSlotParams()
    End Sub
    Private Sub txt_NumSlot2_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_NumSlot2.TextChanged
        Slot(1) = CInt(Val(txt_NumSlot2.Text))
        If Not EventsAreEnabled Then Return
        SetSlotParams()
    End Sub
    Private Sub txt_NumSlot3_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_NumSlot3.TextChanged
        Slot(2) = CInt(Val(txt_NumSlot3.Text))
        If Not EventsAreEnabled Then Return
        SetSlotParams()
    End Sub
    Private Sub txt_NumSlot4_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_NumSlot4.TextChanged
        Slot(3) = CInt(Val(txt_NumSlot4.Text))
        If Not EventsAreEnabled Then Return
        SetSlotParams()
    End Sub
    Private Sub txt_NumSlot5_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_NumSlot5.TextChanged
        Slot(4) = CInt(Val(txt_NumSlot5.Text))
        If Not EventsAreEnabled Then Return
        SetSlotParams()
    End Sub
    Private Sub txt_NumSlot6_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_NumSlot6.TextChanged
        Slot(5) = CInt(Val(txt_NumSlot6.Text))
        If Not EventsAreEnabled Then Return
        SetSlotParams()
    End Sub
    Private Sub txt_NumSlot7_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_NumSlot7.TextChanged
        Slot(6) = CInt(Val(txt_NumSlot7.Text))
        If Not EventsAreEnabled Then Return
        SetSlotParams()
    End Sub
    Private Sub txt_NumSlot8_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_NumSlot8.TextChanged
        Slot(7) = CInt(Val(txt_NumSlot8.Text))
        If Not EventsAreEnabled Then Return
        SetSlotParams()
    End Sub
    Private Sub txt_NumSlot9_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_NumSlot9.TextChanged
        Slot(8) = CInt(Val(txt_NumSlot9.Text))
        If Not EventsAreEnabled Then Return
        SetSlotParams()
    End Sub
    Private Sub txt_NumSlot10_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_NumSlot10.TextChanged
        Slot(9) = CInt(Val(txt_NumSlot10.Text))
        If Not EventsAreEnabled Then Return
        SetSlotParams()
    End Sub
    Private Sub txt_NumSlot111_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_NumSlot11.TextChanged
        Slot(10) = CInt(Val(txt_NumSlot11.Text))
        If Not EventsAreEnabled Then Return
        SetSlotParams()
    End Sub
    Private Sub txt_NumSlot12_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_NumSlot12.TextChanged
        Slot(11) = CInt(Val(txt_NumSlot12.Text))
        If Not EventsAreEnabled Then Return
        SetSlotParams()
    End Sub


    Private Sub cmb_Type1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type1.SelectedIndexChanged
        SensorType(0) = CStr(cmb_Type1.SelectedItem)
        SetSlotParams()
    End Sub
    Private Sub cmb_Type2_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type2.SelectedIndexChanged
        SensorType(1) = CStr(cmb_Type2.SelectedItem)
        SetSlotParams()
    End Sub
    Private Sub cmb_Type3_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type3.SelectedIndexChanged
        SensorType(2) = CStr(cmb_Type3.SelectedItem)
        SetSlotParams()
    End Sub
    Private Sub cmb_Type4_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type4.SelectedIndexChanged
        SensorType(3) = CStr(cmb_Type4.SelectedItem)
        SetSlotParams()
    End Sub
    Private Sub cmb_Type5_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type5.SelectedIndexChanged
        SensorType(4) = CStr(cmb_Type5.SelectedItem)
        SetSlotParams()
    End Sub
    Private Sub cmb_Type6_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type6.SelectedIndexChanged
        SensorType(5) = CStr(cmb_Type6.SelectedItem)
        SetSlotParams()
    End Sub
    Private Sub cmb_Type7_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type7.SelectedIndexChanged
        SensorType(6) = CStr(cmb_Type7.SelectedItem)
        SetSlotParams()
    End Sub
    Private Sub cmb_Type8_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type8.SelectedIndexChanged
        SensorType(7) = CStr(cmb_Type8.SelectedItem)
        SetSlotParams()
    End Sub
    Private Sub cmb_Type9_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type9.SelectedIndexChanged
        SensorType(8) = CStr(cmb_Type9.SelectedItem)
        SetSlotParams()
    End Sub
    Private Sub cmb_Type10_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type10.SelectedIndexChanged
        SensorType(9) = CStr(cmb_Type10.SelectedItem)
        SetSlotParams()
    End Sub
    Private Sub cmb_Type11_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type11.SelectedIndexChanged
        SensorType(10) = CStr(cmb_Type11.SelectedItem)
        SetSlotParams()
    End Sub
    Private Sub cmb_Type12_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type12.SelectedIndexChanged
        SensorType(11) = CStr(cmb_Type12.SelectedItem)
        SetSlotParams()
    End Sub


    Private Sub cmb_Type1_DropDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type1.DropDown
        DropDown(cmb_Type1, txt_SensorMult1)
    End Sub
    Private Sub cmb_Type2_DropDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type2.DropDown
        DropDown(cmb_Type2, txt_SensorMult2)
    End Sub
    Private Sub cmb_Type3_DropDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type3.DropDown
        DropDown(cmb_Type3, txt_SensorMult3)
    End Sub
    Private Sub cmb_Type4_DropDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type4.DropDown
        DropDown(cmb_Type4, txt_SensorMult4)
    End Sub
    Private Sub cmb_Type5_DropDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type5.DropDown
        DropDown(cmb_Type5, txt_SensorMult5)
    End Sub
    Private Sub cmb_Type6_DropDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type6.DropDown
        DropDown(cmb_Type6, txt_SensorMult6)
    End Sub
    Private Sub cmb_Type7_DropDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type7.DropDown
        DropDown(cmb_Type7, txt_SensorMult7)
    End Sub
    Private Sub cmb_Type8_DropDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type8.DropDown
        DropDown(cmb_Type8, txt_SensorMult8)
    End Sub
    Private Sub cmb_Type9_DropDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type9.DropDown
        DropDown(cmb_Type9, txt_SensorMult9)
    End Sub
    Private Sub cmb_Type10_DropDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type10.DropDown
        DropDown(cmb_Type10, txt_SensorMult10)
    End Sub
    Private Sub cmb_Type11_DropDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type11.DropDown
        DropDown(cmb_Type11, txt_SensorMult11)
    End Sub
    Private Sub cmb_Type12_DropDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type12.DropDown
        DropDown(cmb_Type12, txt_SensorMult12)
    End Sub

    Private Sub DropDown(ByRef cmb As MyComboBox, ByRef txt As MyTextBox)
        cmb.ItemHeight = 16
    End Sub

    Private Sub cmb_Type1_DropDownClosed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type1.DropDownClosed
        DropDownClosed(cmb_Type1, txt_SensorMult1)
    End Sub
    Private Sub cmb_Type2_DropDownClosed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type2.DropDownClosed
        DropDownClosed(cmb_Type2, txt_SensorMult2)
    End Sub
    Private Sub cmb_Type3_DropDownClosed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type3.DropDownClosed
        DropDownClosed(cmb_Type3, txt_SensorMult3)
    End Sub
    Private Sub cmb_Type4_DropDownClosed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type4.DropDownClosed
        DropDownClosed(cmb_Type4, txt_SensorMult4)
    End Sub
    Private Sub cmb_Type5_DropDownClosed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type5.DropDownClosed
        DropDownClosed(cmb_Type5, txt_SensorMult5)
    End Sub
    Private Sub cmb_Type6_DropDownClosed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type6.DropDownClosed
        DropDownClosed(cmb_Type6, txt_SensorMult6)
    End Sub
    Private Sub cmb_Type7_DropDownClosed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type7.DropDownClosed
        DropDownClosed(cmb_Type7, txt_SensorMult7)
    End Sub
    Private Sub cmb_Type8_DropDownClosed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type8.DropDownClosed
        DropDownClosed(cmb_Type8, txt_SensorMult8)
    End Sub
    Private Sub cmb_Type9_DropDownClosed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type9.DropDownClosed
        DropDownClosed(cmb_Type9, txt_SensorMult9)
    End Sub
    Private Sub cmb_Type10_DropDownClosed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type10.DropDownClosed
        DropDownClosed(cmb_Type10, txt_SensorMult10)
    End Sub
    Private Sub cmb_Type11_DropDownClosed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type11.DropDownClosed
        DropDownClosed(cmb_Type11, txt_SensorMult11)
    End Sub
    Private Sub cmb_Type12_DropDownClosed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Type12.DropDownClosed
        DropDownClosed(cmb_Type12, txt_SensorMult12)
    End Sub
    Private Sub DropDownClosed(ByRef cmb As MyComboBox, ByRef txt As MyTextBox)
        cmb.ItemHeight = 12
        If cmb.Text.StartsWith("PT") Then
            If txt.NumericValue < 10 Then txt.NumericValue = 10000
        Else
            If txt.NumericValue > 10 Then txt.NumericValue = 1
        End If
    End Sub

    Private Sub txt_SensorMult1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorMult1.TextChanged
        SensorMultiplier(0) = CSng(txt_SensorMult1.NumericValue)
    End Sub
    Private Sub txt_SensorMult2_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorMult2.TextChanged
        SensorMultiplier(1) = CSng(txt_SensorMult2.NumericValue)
    End Sub
    Private Sub txt_SensorMult3_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorMult3.TextChanged
        SensorMultiplier(2) = CSng(txt_SensorMult3.NumericValue)
    End Sub
    Private Sub txt_SensorMult4_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorMult4.TextChanged
        SensorMultiplier(3) = CSng(txt_SensorMult4.NumericValue)
    End Sub
    Private Sub txt_SensorMult5_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorMult5.TextChanged
        SensorMultiplier(4) = CSng(txt_SensorMult5.NumericValue)
    End Sub
    Private Sub txt_SensorMult6_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorMult6.TextChanged
        SensorMultiplier(5) = CSng(txt_SensorMult6.NumericValue)
    End Sub
    Private Sub txt_SensorMult7_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorMult7.TextChanged
        SensorMultiplier(6) = CSng(txt_SensorMult7.NumericValue)
    End Sub
    Private Sub txt_SensorMult8_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorMult8.TextChanged
        SensorMultiplier(7) = CSng(txt_SensorMult8.NumericValue)
    End Sub
    Private Sub txt_SensorMult9_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorMult9.TextChanged
        SensorMultiplier(8) = CSng(txt_SensorMult9.NumericValue)
    End Sub
    Private Sub txt_SensorMult10_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorMult10.TextChanged
        SensorMultiplier(9) = CSng(txt_SensorMult10.NumericValue)
    End Sub
    Private Sub txt_SensorMult11_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorMult11.TextChanged
        SensorMultiplier(10) = CSng(txt_SensorMult11.NumericValue)
    End Sub
    Private Sub txt_SensorMult12_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorMult12.TextChanged
        SensorMultiplier(11) = CSng(txt_SensorMult12.NumericValue)
    End Sub



    Private Sub txt_SensorTrim1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorTrim1.TextChanged
        SensorTrim(0) = CSng(txt_SensorTrim1.NumericValue)
    End Sub
    Private Sub txt_SensorTrim2_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorTrim2.TextChanged
        SensorTrim(1) = CSng(txt_SensorTrim2.NumericValue)
    End Sub
    Private Sub txt_SensorTrim3_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorTrim3.TextChanged
        SensorTrim(2) = CSng(txt_SensorTrim3.NumericValue)
    End Sub
    Private Sub txt_SensorTrim4_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorTrim4.TextChanged
        SensorTrim(3) = CSng(txt_SensorTrim4.NumericValue)
    End Sub
    Private Sub txt_SensorTrim5_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorTrim5.TextChanged
        SensorTrim(4) = CSng(txt_SensorTrim5.NumericValue)
    End Sub
    Private Sub txt_SensorTrim6_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorTrim6.TextChanged
        SensorTrim(5) = CSng(txt_SensorTrim6.NumericValue)
    End Sub
    Private Sub txt_SensorTrim7_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorTrim7.TextChanged
        SensorTrim(6) = CSng(txt_SensorTrim7.NumericValue)
    End Sub
    Private Sub txt_SensorTrim8_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorTrim8.TextChanged
        SensorTrim(7) = CSng(txt_SensorTrim8.NumericValue)
    End Sub
    Private Sub txt_SensorTrim9_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorTrim9.TextChanged
        SensorTrim(8) = CSng(txt_SensorTrim9.NumericValue)
    End Sub
    Private Sub txt_SensorTrim10_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorTrim10.TextChanged
        SensorTrim(9) = CSng(txt_SensorTrim10.NumericValue)
    End Sub
    Private Sub txt_SensorTrim11_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorTrim11.TextChanged
        SensorTrim(10) = CSng(txt_SensorTrim11.NumericValue)
    End Sub
    Private Sub txt_SensorTrim12_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SensorTrim12.TextChanged
        SensorTrim(11) = CSng(txt_SensorTrim12.NumericValue)
    End Sub

    Private Sub btn_Zero1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Zero1.Click
        SetZero(0)
        txt_SensorTrim1.NumericValue = SensorTrim(0)
    End Sub
    Private Sub btn_Zero2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Zero2.Click
        SetZero(1)
        txt_SensorTrim2.NumericValue = SensorTrim(1)
    End Sub
    Private Sub btn_Zero3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Zero3.Click
        SetZero(2)
        txt_SensorTrim3.NumericValue = SensorTrim(2)
    End Sub
    Private Sub btn_Zero4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Zero4.Click
        SetZero(3)
        txt_SensorTrim4.NumericValue = SensorTrim(3)
    End Sub
    Private Sub btn_Zero5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Zero5.Click
        SetZero(4)
        txt_SensorTrim5.NumericValue = SensorTrim(4)
    End Sub
    Private Sub btn_Zero6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Zero6.Click
        SetZero(5)
        txt_SensorTrim6.NumericValue = SensorTrim(5)
    End Sub
    Private Sub btn_Zero7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Zero7.Click
        SetZero(6)
        txt_SensorTrim7.NumericValue = SensorTrim(6)
    End Sub
    Private Sub btn_Zero8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Zero8.Click
        SetZero(7)
        txt_SensorTrim8.NumericValue = SensorTrim(7)
    End Sub
    Private Sub btn_Zero9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Zero9.Click
        SetZero(8)
        txt_SensorTrim8.NumericValue = SensorTrim(8)
    End Sub
    Private Sub btn_Zero10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Zero10.Click
        SetZero(9)
        txt_SensorTrim8.NumericValue = SensorTrim(9)
    End Sub
    Private Sub btn_Zero11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Zero11.Click
        SetZero(10)
        txt_SensorTrim8.NumericValue = SensorTrim(10)
    End Sub
    Private Sub btn_Zero12_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Zero12.Click
        SetZero(11)
        txt_SensorTrim8.NumericValue = SensorTrim(11)
    End Sub

    Private Sub SetZero(ByVal channel As Int32)
        SensorTrim(channel) = -MultipliedValue(channel)
    End Sub

    Friend Sub SetSlotParams()
        If WindowState = FormWindowState.Minimized Then Return
        SlotName(0) = SlotNames(Slot(0))
        SlotName(1) = SlotNames(Slot(1))
        SlotName(2) = SlotNames(Slot(2))
        SlotName(3) = SlotNames(Slot(3))
        SlotName(4) = SlotNames(Slot(4))
        SlotName(5) = SlotNames(Slot(5))
        SlotName(6) = SlotNames(Slot(6))
        SlotName(7) = SlotNames(Slot(7))
        SlotName(8) = SlotNames(Slot(8))
        SlotName(9) = SlotNames(Slot(9))
        SlotName(10) = SlotNames(Slot(10))
        SlotName(11) = SlotNames(Slot(11))
        '
        TXT_Name1.Text = If(cmb_Type1.SelectedIndex > 0, SlotName(0), "")
        TXT_Name2.Text = If(cmb_Type2.SelectedIndex > 0, SlotName(1), "")
        TXT_Name3.Text = If(cmb_Type3.SelectedIndex > 0, SlotName(2), "")
        TXT_Name4.Text = If(cmb_Type4.SelectedIndex > 0, SlotName(3), "")
        TXT_Name5.Text = If(cmb_Type5.SelectedIndex > 0, SlotName(4), "")
        TXT_Name6.Text = If(cmb_Type6.SelectedIndex > 0, SlotName(5), "")
        TXT_Name7.Text = If(cmb_Type7.SelectedIndex > 0, SlotName(6), "")
        TXT_Name8.Text = If(cmb_Type8.SelectedIndex > 0, SlotName(7), "")
        TXT_Name9.Text = If(cmb_Type9.SelectedIndex > 0, SlotName(8), "")
        TXT_Name10.Text = If(cmb_Type10.SelectedIndex > 0, SlotName(9), "")
        TXT_Name11.Text = If(cmb_Type11.SelectedIndex > 0, SlotName(10), "")
        TXT_Name12.Text = If(cmb_Type12.SelectedIndex > 0, SlotName(11), "")
    End Sub


    ' ==============================================================================================================
    '  VISUALIZATION TIMER
    ' ==============================================================================================================
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        '
        ' ----------------------------------------------------- Poll the TEXT COMMANDS SLOT
        PollTextCommandsSlot()
        ' ----------------------------------------------------- Test SlotFile and reload it if changed
        TestSlotFile()
        ' ----------------------------------------------------- Show values to the user
        If WindowState = FormWindowState.Minimized Then Return
        lbl_Display.Text = LogLine
        txt_SlotDisplay1.Text = ConvertedValue(0).ToString("0.#####", GCI)
        txt_SlotDisplay2.Text = ConvertedValue(1).ToString("0.#####", GCI)
        txt_SlotDisplay3.Text = ConvertedValue(2).ToString("0.#####", GCI)
        txt_SlotDisplay4.Text = ConvertedValue(3).ToString("0.#####", GCI)
        txt_SlotDisplay5.Text = ConvertedValue(4).ToString("0.#####", GCI)
        txt_SlotDisplay6.Text = ConvertedValue(5).ToString("0.#####", GCI)
        txt_SlotDisplay7.Text = ConvertedValue(6).ToString("0.#####", GCI)
        txt_SlotDisplay8.Text = ConvertedValue(7).ToString("0.#####", GCI)
        txt_SlotDisplay9.Text = ConvertedValue(8).ToString("0.#####", GCI)
        txt_SlotDisplay10.Text = ConvertedValue(9).ToString("0.#####", GCI)
        txt_SlotDisplay11.Text = ConvertedValue(10).ToString("0.#####", GCI)
        txt_SlotDisplay12.Text = ConvertedValue(11).ToString("0.#####", GCI)
    End Sub

End Class
