﻿Module Module_TextCommands

    ' ===============================================================================================================
    '  TEST COMMAND SLOT and WRITE RESPONSES 
    ' ===============================================================================================================
    Friend CommandsSlot As Int32 = 1

    Friend Sub EnsureSafeValueToTextSlots()
        StringSlots.WriteString(CommandsSlot, "")
    End Sub

    Private PollCommandSlotSyncLock As Object = New Object
    Private TextCommand As String
    Private TextCommandLowerCase As String
    Private TextCommandParameters As String
    Private ResponseString As String
    Friend Sub PollTextCommandsSlot()
        SyncLock PollCommandSlotSyncLock
            If CommandsSlot >= 0 Then
                ResponseString = "OK"
                TextCommand = StringSlots.ReadString(CommandsSlot)
                If TextCommand <> "" Then
                    ' ------------------------------------------------------------- remove spaces and comments
                    RemoveComments(TextCommand)
                    TextCommand = ReplaceMultipleSpacesAndTabAndTrim(TextCommand)
                    ' ------------------------------------------------------------- 
                    'TextCommandFirstWord = TextCommand.Replace(vbTab, " ").Split(" "c)(0)
                    TextCommandParameters = RemoveFirstWord(TextCommand)
                    ' ------------------------------------------------------------- prepare lower case
                    TextCommandLowerCase = TextCommand.ToLower
                    ' ------------------------------------------------------------- split line
                    Dim sa() As String = TextCommandLowerCase.Split(" "c)
                    If sa.Length = 0 Then Return
                    ' ------------------------------------------------------------- extract params
                    Dim n(9) As Double
                    If sa.Length < n.Length Then
                        For i As Int32 = 1 To n.Length - 1
                            If i < sa.Length Then
                                n(i) = CDbl(Val(sa(i)))
                            End If
                        Next
                    End If
                    ' ------------------------------------------------------------- COMMANDS
                    Select Case sa(0)
                        ' ----------------------------------------------------- Toolbar commands
                        Case "logrun"
                            Form1.CHK_Run.Checked = True
                        Case "logstop"
                            Form1.CHK_Run.Checked = False
                        Case "logpause"
                            FastTimer_Stop()
                            Form1.CHK_Run.Text = "PAUSED"
                        Case "logresume"
                            FastTimer_Start()
                            Form1.SetRunButtonDefaultText()
                        Case "backupfile"
                            BackupLogFile()
                        Case "recordinginterval"
                            Form1.TXT_Interval.NumericValue = n(1)
                            ' ------------------------------------------------- Error
                        Case Else
                            SetError("Command not recognized: " + TextCommand)
                    End Select
                    ' --------------------------------------------------------- UPDATE RESPONSE
                    StringSlots.WriteString(CommandsSlot, "")
                End If
            End If
        End SyncLock
    End Sub

    Private Sub SetError(ByVal err As String)
        ResponseString = err
        Console.Beep(660, 50)
        Console.Beep(440, 50)
        Console.Beep(220, 150)
    End Sub

End Module
